%%%%%%%%%%%%%%real time%%%%%%%%%%
rxd=rxd';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%Synchronization%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
decision_mtx=zeros(1,(length(rxd)-length(Ts)));
for i=1:length(decision_mtx)
temp=rxd(i:(i+length(Ts))-1);
temp1=sum(temp.*Ts);
correlated(i)=temp1;
end
[x,j]=sort(correlated,2,'descend');
start=j(1);
stop=j(2);
% while (abs(stop-start) < length(settings.T_S))
% stop = i(j);
% j = j+1;
% end
if (stop<=start)

temp = stop;
stop = start;
start = temp;
end

rxdsync=rxd(start+length(Ts):stop-1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%DE-root raised Cosine%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
rrcos_filt = rcosine(1,Fd,'fir/sqrt',rolloff,delay);
recoverd_mod= rcosflt(rxdsync,1,Fd,'Fs/filter',rrcos_filt);
recoverd_mod = downsample(recoverd_mod,Fd); % Downsample.
recoverd_mod = recoverd_mod(2*delay+1:end-2*delay); % Account for delay.
recoverd_mod=recoverd_mod';
%%%%%%%%%%%%%%%%%%phase recovery%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
extra = length(recoverd_mod)- length(Code_1_up);
recoverd_mod = recoverd_mod(1:end-extra);

t1 = 0:1/fs:(length(recoverd_mod)-1)/fs;
carrier = sin(2*pi*fc*t1);
dem = carrier.*recoverd_mod;


de_spread1=dem.*Code_1_up;
de_spread2=dem.*Code_2_up;
de_spread3=dem.*Code_3_up;
de_spread4=dem.*Code_4_up;
de_spread5=dem.*Code_5_up;
de_spread6=dem.*Code_6_up;
de_spread7=dem.*Code_7_up;
de_spread8=dem.*Code_8_up;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Extracting Individual Users%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User1%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread1 = reshape(de_spread1,8*22,[]);
dim1 =size(msg_despread1);
msg_despread1 = msg_despread1(:)';

temporal=0;
for i=1:dim1(2)
djixstras = msg_despread1(i+temporal-(i-1):dim1(1)+temporal);
sig_retreived1(i) = sum(djixstras);
temporal=temporal+dim1(1);
end    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User2%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread2 = reshape(de_spread2,8*22,[]);
dim2 =size(msg_despread2);
msg_despread2 = msg_despread2(:)';

temporal=0;
for i=1:dim2(2)
djixstras = msg_despread2(i+temporal-(i-1):dim2(1)+temporal);
sig_retreived2(i) = sum(djixstras);
temporal=temporal+dim2(1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User3%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread3 = reshape(de_spread3,8*22,[]);
dim3 =size(msg_despread3);
msg_despread3 = msg_despread3(:)';

temporal=0;
for i=1:dim3(2)
djixstras = msg_despread3(i+temporal-(i-1):dim3(1)+temporal);
sig_retreived3(i) = sum(djixstras);
temporal=temporal+dim3(1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User4%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread4 = reshape(de_spread4,8*22,[]);
dim4 =size(msg_despread4);
msg_despread4 = msg_despread4(:)';

temporal=0;
for i=1:dim4(2)
djixstras = msg_despread4(i+temporal-(i-1):dim4(1)+temporal);
sig_retreived4(i) = sum(djixstras);
temporal=temporal+dim4(1);
end    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User5%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread5 = reshape(de_spread5,8*22,[]);
dim5 =size(msg_despread5);
msg_despread5 = msg_despread5(:)';

temporal=0;
for i=1:dim5(2)
djixstras = msg_despread5(i+temporal-(i-1):dim5(1)+temporal);
sig_retreived5(i) = sum(djixstras);
temporal=temporal+dim5(1);
end    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User6%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread6 = reshape(de_spread6,8*22,[]);
dim6 =size(msg_despread6);
msg_despread6 = msg_despread6(:)';

temporal=0;
for i=1:dim6(2)
djixstras = msg_despread6(i+temporal-(i-1):dim6(1)+temporal);
sig_retreived6(i) = sum(djixstras);
temporal=temporal+dim6(1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User7%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread7 = reshape(de_spread7,8*22,[]);
dim7 =size(msg_despread7);
msg_despread7 = msg_despread7(:)';

temporal=0;
for i=1:dim3(2)
djixstras = msg_despread7(i+temporal-(i-1):dim7(1)+temporal);
sig_retreived7(i) = sum(djixstras);
temporal=temporal+dim7(1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User8%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread8 = reshape(de_spread8,8*22,[]);
dim8 =size(msg_despread8);
msg_despread8 = msg_despread8(:)';

temporal=0;
for i=1:dim8(2)
djixstras = msg_despread8(i+temporal-(i-1):dim8(1)+temporal);
sig_retreived8(i) = sum(djixstras);
temporal=temporal+dim8(1);
end    

sig1 = sig_retreived1>0;
sig2 = sig_retreived2>0;
sig3 = sig_retreived3>0;
sig4 = sig_retreived4>0;
sig5 = sig_retreived5>0;
sig6 = sig_retreived6>0;
sig7 = sig_retreived7>0;
sig8 = sig_retreived8>0;

figure(1)
subplot(2,1,1)
stem(msg_orig1,'.');
subplot(2,1,2)
stem(sig1,'.');

figure(2)
subplot(2,1,1)
stem(msg_orig2,'.');
subplot(2,1,2)
stem(sig2,'.');

figure(3)
subplot(2,1,1)
stem(msg_orig3,'.');
subplot(2,1,2)
stem(sig3,'.');

figure(4)
subplot(2,1,1)
stem(msg_orig4,'.');
subplot(2,1,2)
stem(sig4,'.');

figure(5)
subplot(2,1,1)
stem(msg_orig5,'.');
subplot(2,1,2)
stem(sig5,'.');

figure(6)
subplot(2,1,1)
stem(msg_orig6,'.');
subplot(2,1,2)
stem(sig6,'.');

figure(7)
subplot(2,1,1)
stem(msg_orig7,'.');
subplot(2,1,2)
stem(sig7,'.');

figure(8)
subplot(2,1,1)
stem(msg_orig8,'.');
subplot(2,1,2)
stem(sig8,'.');