%%%BER%%%%%
%%%%%%%%%%%%%%%%Transmitter%%%%%%%%%%%%%%%%%%%%%
fs=44000;
fc=2000;
drate = 2000;
N=8;
M=ceil(log(N)/log(2));
if 2^M==1;
W=[1];
else if 2^M==2;
W=[1 1;1 -1];
else W=[1 1 1 1;1 -1 1 -1;1 1 -1 -1;1 -1 -1 1];
for k=1:M-2
W=[W W;W -W];
end
end
end
disp(W)
Code_1=W(1,:);
Code_2=W(2,:);
Code_3=W(3,:);
Code_4=W(4,:);
Code_5=W(5,:);
Code_6=W(6,:);
Code_7=W(7,:);
Code_8=W(8,:);

msg_orig1 = randint(1,10000);
msg_orig2 = randint(1,10000);
msg_orig3 = randint(1,10000);
msg_orig4 = randint(1,10000);
msg_orig5 = randint(1,10000);
msg_orig6 = randint(1,10000);
msg_orig7 = randint(1,10000);
msg_orig8 = randint(1,10000);

up_samp = 22*length(Code_1);

msg_NRZ1=2*msg_orig1-1;
msg_NRZ1 = (msg_NRZ1' * ones(1,up_samp))';
msg_NRZ1 = msg_NRZ1(:)';

msg_NRZ2=2*msg_orig2-1;
msg_NRZ2 = (msg_NRZ2' * ones(1,up_samp))';
msg_NRZ2 = msg_NRZ2(:)';

msg_NRZ3=2*msg_orig3-1;
msg_NRZ3 = (msg_NRZ3' * ones(1,up_samp))';
msg_NRZ3 = msg_NRZ3(:)';

msg_NRZ4=2*msg_orig4-1;
msg_NRZ4 = (msg_NRZ4' * ones(1,up_samp))';
msg_NRZ4 = msg_NRZ4(:)';

msg_NRZ5=2*msg_orig5-1;
msg_NRZ5 = (msg_NRZ5' * ones(1,up_samp))';
msg_NRZ5 = msg_NRZ5(:)';

msg_NRZ6=2*msg_orig6-1;
msg_NRZ6 = (msg_NRZ6' * ones(1,up_samp))';
msg_NRZ6 = msg_NRZ6(:)';

msg_NRZ7=2*msg_orig7-1;
msg_NRZ7 = (msg_NRZ7' * ones(1,up_samp))';
msg_NRZ7 = msg_NRZ7(:)';

msg_NRZ8=2*msg_orig8-1;
msg_NRZ8 = (msg_NRZ8' * ones(1,up_samp))';
msg_NRZ8 = msg_NRZ8(:)';

Code_1_up = repmat(Code_1,1,length(msg_orig1));
Code_1_up = (Code_1_up' * ones(1,22))';
Code_1_up = Code_1_up(:)';

Code_2_up = repmat(Code_2,1,length(msg_orig2));
Code_2_up = (Code_2_up' * ones(1,22))';
Code_2_up = Code_2_up(:)';

Code_3_up = repmat(Code_3,1,length(msg_orig3));
Code_3_up = (Code_3_up' * ones(1,22))';
Code_3_up = Code_3_up(:)';

Code_4_up = repmat(Code_4,1,length(msg_orig4));
Code_4_up = (Code_4_up' * ones(1,22))';
Code_4_up = Code_4_up(:)';

Code_5_up = repmat(Code_5,1,length(msg_orig5));
Code_5_up = (Code_5_up' * ones(1,22))';
Code_5_up = Code_5_up(:)';

Code_6_up = repmat(Code_6,1,length(msg_orig6));
Code_6_up = (Code_6_up' * ones(1,22))';
Code_6_up = Code_6_up(:)';

Code_7_up = repmat(Code_7,1,length(msg_orig7));
Code_7_up = (Code_7_up' * ones(1,22))';
Code_7_up = Code_7_up(:)';

Code_8_up = repmat(Code_8,1,length(msg_orig8));
Code_8_up = (Code_8_up' * ones(1,22))';
Code_8_up = Code_8_up(:)';

spreaded1=Code_1_up.*msg_NRZ1;     %%%%%%%% Spreading%%%%%%%%
spreaded2=Code_2_up.*msg_NRZ2;
spreaded3=Code_3_up.*msg_NRZ3;
spreaded4=Code_4_up.*msg_NRZ4;
spreaded5=Code_5_up.*msg_NRZ5;     
spreaded6=Code_6_up.*msg_NRZ6;
spreaded7=Code_7_up.*msg_NRZ7;
spreaded8=Code_8_up.*msg_NRZ8;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Modulation%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
l=length(spreaded1);
t=0:1/1/fs:(1/fc-1/fs);
c=sin(2*pi*fc*t);

p=0;
for j=1:l/22
for i=1:22
mod_1(i+p)=spreaded1(i+p).*c(i);
end
p=p+22;
end

p=0;
for j=1:l/22
for i=1:22
mod_2(i+p)=spreaded2(i+p).*c(i);
end
p=p+22;
end

p=0;
for j=1:l/22
for i=1:22
mod_3(i+p)=spreaded3(i+p).*c(i);
end
p=p+22;
end

p=0;
for j=1:l/22
for i=1:22
mod_4(i+p)=spreaded4(i+p).*c(i);
end
p=p+22;
end

p=0;
for j=1:l/22
for i=1:22
mod_5(i+p)=spreaded5(i+p).*c(i);
end
p=p+22;
end


p=0;
for j=1:l/22
for i=1:22
mod_6(i+p)=spreaded6(i+p).*c(i);
end
p=p+22;
end

p=0;
for j=1:l/22
for i=1:22
mod_7(i+p)=spreaded7(i+p).*c(i);
end
p=p+22;
end

p=0;
for j=1:l/22
for i=1:22
mod_8(i+p)=spreaded8(i+p).*c(i);
end
p=p+22;
end


sum_mod = mod_1 + mod_2 + mod_3 + mod_4 + mod_5 + mod_6 + mod_7 + mod_8;
norm_mod = sum_mod/max(sum_mod);

Fd=fs/drate;
rolloff=0.5;
delay=3;
rrcos_filt = rcosine(1,Fd,'fir/sqrt',rolloff,delay);

shaped_msg=rcosflt(norm_mod,1,Fd,'filter',rrcos_filt);
norm_shaped=shaped_msg/max(shaped_msg);
norm_shaped=norm_shaped';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%555point%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
EbNo = 0:2:20;
for dump = 1:11
    rxd = awgn(norm_shaped,EbNo(dump));
    rxdsync=rxd;
    rrcos_filt = rcosine(1,Fd,'fir/sqrt',rolloff,delay);
recoverd_mod= rcosflt(rxdsync,1,Fd,'Fs/filter',rrcos_filt);
recoverd_mod = downsample(recoverd_mod,Fd); % Downsample.
recoverd_mod = recoverd_mod(2*delay+1:end-2*delay); % Account for delay.
recoverd_mod=recoverd_mod';
%%%%%%%%%%%%%%%%%%phase recovery%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
t1 = 0:1/fs:(length(recoverd_mod)-1)/fs;
carrier = sin(2*pi*fc*t1);
dem = carrier.*recoverd_mod;


de_spread1=dem.*Code_1_up;
de_spread2=dem.*Code_2_up;
de_spread3=dem.*Code_3_up;
de_spread4=dem.*Code_4_up;
de_spread5=dem.*Code_5_up;
de_spread6=dem.*Code_6_up;
de_spread7=dem.*Code_7_up;
de_spread8=dem.*Code_8_up;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Extracting Individual Users%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User1%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread1 = reshape(de_spread1,8*22,[]);
dim1 =size(msg_despread1);
msg_despread1 = msg_despread1(:)';

temporal=0;
for i=1:dim1(2)
djixstras = msg_despread1(i+temporal-(i-1):dim1(1)+temporal);
sig_retreived1(i) = sum(djixstras);
temporal=temporal+dim1(1);
end    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User2%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread2 = reshape(de_spread2,8*22,[]);
dim2 =size(msg_despread2);
msg_despread2 = msg_despread2(:)';

temporal=0;
for i=1:dim2(2)
djixstras = msg_despread2(i+temporal-(i-1):dim2(1)+temporal);
sig_retreived2(i) = sum(djixstras);
temporal=temporal+dim2(1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User3%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread3 = reshape(de_spread3,8*22,[]);
dim3 =size(msg_despread3);
msg_despread3 = msg_despread3(:)';

temporal=0;
for i=1:dim3(2)
djixstras = msg_despread3(i+temporal-(i-1):dim3(1)+temporal);
sig_retreived3(i) = sum(djixstras);
temporal=temporal+dim3(1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User4%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread4 = reshape(de_spread4,8*22,[]);
dim4 =size(msg_despread4);
msg_despread4 = msg_despread4(:)';

temporal=0;
for i=1:dim4(2)
djixstras = msg_despread4(i+temporal-(i-1):dim4(1)+temporal);
sig_retreived4(i) = sum(djixstras);
temporal=temporal+dim4(1);
end    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User5%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread5 = reshape(de_spread5,8*22,[]);
dim5 =size(msg_despread5);
msg_despread5 = msg_despread5(:)';

temporal=0;
for i=1:dim5(2)
djixstras = msg_despread5(i+temporal-(i-1):dim5(1)+temporal);
sig_retreived5(i) = sum(djixstras);
temporal=temporal+dim5(1);
end    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User6%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread6 = reshape(de_spread6,8*22,[]);
dim6 =size(msg_despread6);
msg_despread6 = msg_despread6(:)';

temporal=0;
for i=1:dim6(2)
djixstras = msg_despread6(i+temporal-(i-1):dim6(1)+temporal);
sig_retreived6(i) = sum(djixstras);
temporal=temporal+dim6(1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User7%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread7 = reshape(de_spread7,8*22,[]);
dim7 =size(msg_despread7);
msg_despread7 = msg_despread7(:)';

temporal=0;
for i=1:dim3(2)
djixstras = msg_despread7(i+temporal-(i-1):dim7(1)+temporal);
sig_retreived7(i) = sum(djixstras);
temporal=temporal+dim7(1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User8%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread8 = reshape(de_spread8,8*22,[]);
dim8 =size(msg_despread8);
msg_despread8 = msg_despread8(:)';

temporal=0;
for i=1:dim8(2)
djixstras = msg_despread8(i+temporal-(i-1):dim8(1)+temporal);
sig_retreived8(i) = sum(djixstras);
temporal=temporal+dim8(1);
end

for i = 1:1000
    if sig_retreived1(i)>=0
        sig1(i) = 1;
    else
        sig1(i) = 0;
    end
end
sig1 = sig_retreived1>0;
sig2 = sig_retreived2>0;
sig3 = sig_retreived3>0;
sig4 = sig_retreived4>0;
sig5 = sig_retreived5>0;
sig6 = sig_retreived6>0;
sig7 = sig_retreived7>0;
sig8 = sig_retreived8>0;

errors1 = xor(msg_orig1,sig1);
errors_errors1 = length(find(errors1 ==1));
BER1(dump) = errors_errors/10000;

errors2 = xor(msg_orig2,sig2);
errors_errors2 = length(find(errors2 ==1));
BER2(dump) = errors_errors2/10000;

errors3 = xor(msg_orig3,sig3);
errors_errors3 = length(find(errors3 ==1));
BER3(dump) = errors_errors3/10000;

errors4 = xor(msg_orig4,sig4);
errors_errors4 = length(find(errors4 ==1));
BER4(dump) = errors_errors4/10000;

errors5 = xor(msg_orig5,sig5);
errors_errors5 = length(find(errors5 ==1));
BER5(dump) = errors_errors5/10000;

errors6 = xor(msg_orig6,sig6);
errors_errors6 = length(find(errors6 ==1));
BER6(dump) = errors_errors6/10000;

errors7 = xor(msg_orig7,sig7);
errors_errors7 = length(find(errors7 ==1));
BER7(dump) = errors_errors7/10000;

errors8 = xor(msg_orig8,sig8);
errors_errors8 = length(find(errors8 ==1));
BER8(dump) = errors_errors8/10000;

end