rxd= wavread('signal');
rxd=rxd';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%Synchronization%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
decision_mtx=zeros(1,(length(rxd)-length(Ts)));
for i=1:length(decision_mtx)
temp=rxd(i:(i+length(Ts))-1);
temp1=sum(temp.*Ts);
correlated(i)=temp1;
end
[x,j]=sort(correlated,2,'descend');
start=j(1);
stop=j(2);
while (abs(stop-start) < length(Ts))
stop = j(sep);
sep = sep+1;
end
if (stop<=start)

temp = stop;
stop = start;
start = temp;
end

rxdsync=rxd(start+length(Ts):stop-1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%DE-root raised Cosine%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
rrcos_filt = rcosine(1,Fd,'fir/sqrt',rolloff,delay);
recoverd_mod= rcosflt(rxdsync,1,Fd,'Fs/filter',rrcos_filt);
recoverd_mod = downsample(recoverd_mod,Fd); % Downsample.
recoverd_mod = recoverd_mod(2*delay+1:end-2*delay); % Account for delay.
recoverd_mod=recoverd_mod';
%%%%%%%%%%%%%%%%%%phase recovery%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
t1 = 0:1/fs:(length(recoverd_mod)-1)/fs;
carrier = sin(2*pi*fc*t1);
dem = carrier.*recoverd_mod;




de_spread1=dem.*Code_1_up;
de_spread2=dem.*Code_2_up;
de_spread3=dem.*Code_3_up;
de_spread4=dem.*Code_4_up;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Extracting Individual Users%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User1%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread1 = reshape(de_spread1,4*44,[]);
dim1 =size(msg_despread1);
msg_despread1 = msg_despread1(:)';

temporal=0;
for i=1:dim1(2)
djixstras = msg_despread1(i+temporal-(i-1):dim1(1)+temporal);
sig_retreived1(i) = sum(djixstras);
temporal=temporal+dim1(1);
end    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User2%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread2 = reshape(de_spread2,4*44,[]);
dim2 =size(msg_despread2);
msg_despread2 = msg_despread2(:)';

temporal=0;
for i=1:dim2(2)
djixstras = msg_despread2(i+temporal-(i-1):dim2(1)+temporal);
sig_retreived2(i) = sum(djixstras);
temporal=temporal+dim2(1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User3%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread3 = reshape(de_spread3,4*44,[]);
dim3 =size(msg_despread3);
msg_despread3 = msg_despread3(:)';

temporal=0;
for i=1:dim3(2)
djixstras = msg_despread3(i+temporal-(i-1):dim3(1)+temporal);
sig_retreived3(i) = sum(djixstras);
temporal=temporal+dim3(1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%User4%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

msg_despread4 = reshape(de_spread4,4*44,[]);
dim4 =size(msg_despread4);
msg_despread4 = msg_despread4(:)';

temporal=0;
for i=1:dim4(2)
djixstras = msg_despread4(i+temporal-(i-1):dim4(1)+temporal);
sig_retreived4(i) = sum(djixstras);
temporal=temporal+dim4(1);
end    



sig1 = sig_retreived1>0;
sig2 = sig_retreived2>0;
sig3 = sig_retreived3>0;
sig4 = sig_retreived4>0;

figure(1)
subplot(2,1,1)
stem(msg_orig1,'.');
subplot(2,1,2)
stem(sig1,'.');

figure(2)
subplot(2,1,1)
stem(msg_orig2,'.');
subplot(2,1,2)
stem(sig2,'.');

figure(3)
subplot(2,1,1)
stem(msg_orig3,'.');
subplot(2,1,2)
stem(sig3,'.');

figure(4)
subplot(2,1,1)
stem(msg_orig4,'.');
subplot(2,1,2)
stem(sig4,'.');
