%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%Parameters%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
drate=1000;
fs=44000;
fc=1000;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%Generating Waslh codes%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N=input('Enter the length of walsh code');
M=ceil(log(N)/log(2));
if 2^M==1;
W=[1];
else if 2^M==2;
W=[1 1;1 -1];
else W=[1 1 1 1;1 -1 1 -1;1 1 -1 -1;1 -1 -1 1];
for k=1:M-2
W=[W W;W -W];
end
end
end
disp(W)
% x=input('enter the codeword number to be selected');
Code_1=W(1,:);
Code_2=W(2,:);
Code_3=W(3,:);
Code_4=W(4,:);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%Upsampling the message signal%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
msg_orig1 = [1 0 1 0 1 0 1 0 1];
msg_orig2 = [0 1 0 1 0 1 0 1 0];
msg_orig3 = [0 0 1 1 0 0 1 1 1];
msg_orig4 = [1 0 0 1 1 0 1 0 1];
%%image=imread('A','bmp');
%%dim=size(image);
%%n=dim(1,1);
%%m=dim(1,2);
%%msg_orig=image(:)';
msg_NRZ1=2*msg_orig1-1;
up_samp = length(Code_1)*44;
msg_NRZ1 = (msg_NRZ1' * ones(1,up_samp))';
msg_NRZ1 = msg_NRZ1(:)';

msg_NRZ2=2*msg_orig2-1;
up_samp = length(Code_2)*44;
msg_NRZ2 = (msg_NRZ2' * ones(1,up_samp))';
msg_NRZ2 = msg_NRZ2(:)';

msg_NRZ3=2*msg_orig3-1;
up_samp = length(Code_3)*44;
msg_NRZ3 = (msg_NRZ3' * ones(1,up_samp))';
msg_NRZ3 = msg_NRZ3(:)';

msg_NRZ4=2*msg_orig4-1;
up_samp = length(Code_4)*44;
msg_NRZ4 = (msg_NRZ4' * ones(1,up_samp))';
msg_NRZ4 = msg_NRZ4(:)';

% msg=msg_NRZ;
%%figure(6);
%%title('Power Spectral Density Estimate of Message Signal via Periodogram');
%%periodogram(msg,[],4096,10000);
%%SNR = 10;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%Upsampling the Walsh Code%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Code_1_up = repmat(Code_1,1,length(msg_orig1));
Code_1_up = (Code_1_up' * ones(1,44))';
Code_1_up = Code_1_up(:)';

Code_2_up = repmat(Code_2,1,length(msg_orig2));
Code_2_up = (Code_2_up' * ones(1,44))';
Code_2_up = Code_2_up(:)';

Code_3_up = repmat(Code_3,1,length(msg_orig3));
Code_3_up = (Code_3_up' * ones(1,44))';
Code_3_up = Code_3_up(:)';

Code_4_up = repmat(Code_4,1,length(msg_orig4));
Code_4_up = (Code_4_up' * ones(1,44))';
Code_4_up = Code_4_up(:)';

spreaded1=Code_1_up.*msg_NRZ1;     %%%%%%%% Spreading%%%%%%%%
spreaded2=Code_2_up.*msg_NRZ2;
spreaded3=Code_3_up.*msg_NRZ3;
spreaded4=Code_4_up.*msg_NRZ4;

% spreaded=spreaded1+spreaded2+spreaded3+spreaded4;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%BPSK Modulation%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
l=length(spreaded1);
t=0:1/44000:43/44000;
c=sin(2*pi*1000*t);
p=0;
for j=1:l/44
for i=1:44
w(i+p)=spreaded1(i+p).*c(i);
end
p=p+44;
end


q=0;
for j=1:l/44
for i=1:44
x(i+q)=spreaded2(i+q).*c(i);
end
q=q+44;
end

r=0;
for j=1:l/44
for i=1:44
y(i+r)=spreaded3(i+r).*c(i);
end
r=r+44;
end

s=0;
for j=1:l/44
for i=1:44
z(i+s)=spreaded4(i+s).*c(i);
end
s=s+44;
end

sum_mod = w+x+y+z;
norm_mod = sum_mod/max(sum_mod);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%Root Raised Cosine Filter%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Fd=fs/drate;
rolloff=0.5;
delay=3;
rrcos_filt = rcosine(1,Fd,'fir/sqrt',rolloff,delay);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%Pulse Shaping%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
shaped_msg=rcosflt(norm_mod,1,Fd,'filter',rrcos_filt);

% shaped_msg=rcosflt(w,1,Fd,'filter',rrcos_filt);
% shaped_msg=shaped_msg';

% shaped_msg1=shaped_msg1';
% shaped_msg2=shaped_msg2';
% shaped_msg3=shaped_msg3';
% shaped_msg4=shaped_msg4';

% shaped_msg=shaped_msg1+shaped_msg2+shaped_msg3+shaped_msg4;

% figure(4);
% subplot(5,1,1);
% stem(msg_NRZ,'.');
% title('NRZ Encoded Message');
% subplot(5,1,2);
% stem(Code_1_up,'.');
% title('generated walsh codeword ')
% subplot(5,1,3);
% stem(spreaded,'.');
% title('Spreaded Signal ')
% subplot(5,1,4);
% plot(y);
% title('BPSK MODULATION');
% subplot(5,1,5);
% plot(shaped_msg);
% title('raised cosine filtering');
%%%%%%%%%%%%%%%%%%%%%%%%%%%Symbol Packing%%%%%%%%%%%
norm_shaped=shaped_msg/max(shaped_msg);
norm_shaped=norm_shaped';
% norm_shaped2=shaped_msg2/max(shaped_msg2);
% norm_shaped3=shaped_msg3/max(shaped_msg3);
% norm_shaped4=shaped_msg4/max(shaped_msg4);
t1=0:1/fs:1/fc;
A=sin(2*pi*fc*t1);
B=cos(2*pi*fc*t1);
Ts = [A A A A B A A A B B A A B B B A B B B B B B B B B B B B B A B B B A A B B A A A B A A A A A A A A A];
% Ts1 = [A A A A B A A A B B A A B B B A B B B B B B B B B B B B B A B B B A A B B A A A B A A A A A A A A A];
% Ts2 = [B B B B A B B B A A B B A A A B A A A A A A A A A A A A A B A A A B B A A B B B A B B B B B B B B B];
% Ts3 = [B A B A A A A A A A A A A A A A A A A A A A A A A A A A A B A A A B B A A B B B A B A B A B A B A B];
% Ts4 = [A B B A A B B B A A B B A A A B A A A A A B B B B B B B B B A A A B B A A B B B A B B B B B B B B B];
L=zeros(1,1000);
Packet = [L Ts norm_shaped Ts L];
sound(Packet,fs);
wavwrite(Packet,44100,'signal.wav');